#ifndef BARAJA
#define BARAJA

#define TREBOLES  0
#define DIAMANTES 1
#define CORAZONES 2
#define PICAS     3

class Naipe {
    public:
    Naipe() : palo(TREBOLES), numero(0), visible(false) {}
    Naipe(int p, int n, int v=false) : palo(p), numero(n), visible(v) {}
    Naipe Sucesor() const;
    Naipe Predecesor() const;
    int Palo() const { return palo; }
    int Numero() const { return numero; }
    int Orden() const;
    bool Visible() const { return visible; }
    void Volver() { visible = !visible; }
    void Levantar() { visible = true; }
    void Ocultar() { visible = false; }
    bool operator==(Naipe n) { return palo==n.palo && numero==n.numero; }

    private:
    int palo;
    int numero;
    bool visible;
};

class Baraja {
    public:
    Baraja();
    void Mezclar();
    const Naipe &Carta(int i) const { return baraja[i]; }

    private:
    Naipe baraja[40];
};

#endif
