#ifndef GRAFICOS
#define GRAFICOS

#include "tapete.h"
#include <windows.h>

class Coor {
    public:
    Coor(int xi=0, int yi=0) : x(xi), y(yi) {}
    int &X() { return x; }
    int &Y() { return y; }

    private:
    int x, y;
};

class Graficos {
    public:
    Graficos(HINSTANCE hInstance, HWND hwnd, Tapete &tapete);
    ~Graficos();
    void Iniciar();
    void MostrarTapete();
    void Puntuacion();
    void MostrarCarta(const Naipe &carta, Coor c, int n=0) {
        MostrarCarta(carta, c.X(), c.Y(), n);
    }
    void MostrarBitmap(HBITMAP hbm, int x, int y);
    void MostrarCarta(const Naipe &carta, int x, int y, int n=0);
    void MostrarMovimiento(int Origen, int Destino);
    int RatonEnZona(int x, int y);
    int ComienzaArrastre(int x, int y);
    void IniciaCaptura(int zona);
    void EnArrastre(int x, int y);
    int FinArrastre(int x, int y);
    void AjustarRegion(int zona);
    Coor CoordenadasZona(int z);
    void CambiarDorso(int d);
    int Dorso() const { return dorso; }
    HINSTANCE Lib() const { return hLib; }
    int W() const { return w; }
    int H() const { return h; }
    HBITMAP Mascara() const { return hMascara; }
    HCURSOR Mover() const { return hMover; }
    HCURSOR Flecha() const { return hFlecha; }

    private:
    HINSTANCE hInstance;
    Tapete &tapete;
    HBRUSH fondo;
    HBITMAP hMascara;
    HBITMAP hDorso;
    int dorso;
    HBITMAP hX;
    HBITMAP hO;
    HBITMAP hNaipe[52];
    HWND hWnd;
    HDC hDC;
    HINSTANCE hLib;
    int w, h;
    Coor zona[10];
    HRGN reg[10];
    HBITMAP hArrastre;
    HCURSOR hMover;
    HCURSOR hFlecha;

    // Movimiento de carta:
    Coor raton;
    Coor desp;
    HDC movDC;
};

#endif
